<template>
  <div>
    <div :class="$style.dayWrapper">
      <span :class="$style.dayNumber">{{ dayNumber }}</span>
      <span :class="$style.dayString"> {{ month }}, {{ dayString }}</span>
    </div>
    <transaction-item
        v-for="transaction in transactions"
        :key="transaction.id"
        :transaction="transaction"
    />
  </div>
</template>

<style module>
.dayWrapper {
  display: flex;
  justify-content: flex-start;
  align-items: flex-end;
  white-space: nowrap;
  margin-top: 15px;
}
.dayNumber {
  font-size: 2rem;
}
.dayString {
  margin: 0 10px;
  line-height: 1.6rem;
}
.dayWrapper:after {
  content: '';
  background-color: #e7e7e7;
  width: 100%;
  position: relative;
  bottom: .7rem;
  height: 1px;
}
</style>

<script>
import moment from 'moment';
import TransactionItem from './TransactionItem';

export default {
  components: {
    TransactionItem,
  },
  props: {
    date: String,
    transactions: Array,
  },
  computed: {
    dayNumber() {
      return this.getLocaleDate(this.date).dayNum;
    },
    month() {
      return this.ucFirst(this.getLocaleDate(this.date).month);
    },
    dayString() {
      return this.ucFirst(this.getLocaleDate(this.date).dayString);
    },
  },
  methods: {
    getLocaleDate(date) {
      const [dayNum, month, dayString] = moment(date, Date.toString())
          .locale('ru')
          .format('D MMMM dddd')
          .split(' ');
      return {dayNum, month, dayString};
    },
    ucFirst(str) {
      return str[0].toUpperCase() + str.slice(1);
    },
  },
}
</script>